HDU1150 Machine Schedule(二分图最大匹配、最小点覆盖)

As we all know, machine scheduling is a very classical problem in computer science and has been studied for a very long history. Scheduling problems differ widely in the nature of the constraints that must be satisfied and the type of schedule desired. Here we consider a 2-machine scheduling problem.

There are two machines A and B. Machine A has n kinds of working modes, which is called mode_0, mode_1, …, mode_n-1, likewise machine B has m kinds of working modes, mode_0, mode_1, … , mode_m-1. At the beginning they are both work at mode_0.

For k jobs given, each of them can be processed in either one of the two machines in particular mode. For example, job 0 can either be processed in machine A at mode_3 or in machine B at mode_4, job 1 can either be processed in machine A at mode_2 or in machine B at mode_4, and so on. Thus, for job i, the constraint can be represent as a triple (i, x, y), which means it can be processed either in machine A at mode_x, or in machine B at mode_y.

Obviously, to accomplish all the jobs, we need to change the machine‘s working mode from time to time, but unfortunately, the machine‘s working mode can only be changed by restarting it manually. By changing the sequence of the jobs and assigning each job to a suitable machine, please write a program to minimize the times of restarting machines.

InputThe input file for this program consists of several configurations. The first line of one configuration contains three positive integers: n, m (n, m < 100) and k (k < 1000). The following k lines give the constrains of the k jobs, each line is a triple: i, x, y.

The input will be terminated by a line containing a single zero. 
OutputThe output should be one integer per line, which means the minimal times of restarting machine. 
Sample Input

5 5 10
0 1 1
1 1 2
2 1 3
3 1 4
4 2 1
5 2 2
6 2 3
7 2 4
8 3 3
9 4 3
0

Sample Output

3

  题意有两台机器A和B以及N个需要运行的任务。每台机器有M种不同的模式,而每个任务都恰好在一台机器上运行。如果它在机器A上运行,则机器A需要设置为模式xi,如果它在机器B上运行,则机器A需要设置为模式yi。每台机器上的任务可以按照任意顺序执行,但是每台机器每转换一次模式需要重启一次。请合理为每个任务安排一台机器并合理安排顺序,使得机器重启次数尽量少(kuangbin大佬的权威解释,比较通俗易懂,就借用一下了,望大佬莫怪罪啊)。

思路:每个任务的两个模式之间建一条边,很显然构成了一张二分图,现在我们需要使重启次数最小,相当于求该图的最小点覆盖。  根据二分图的特性--最小点覆盖=最大匹配数,可以轻松做出此题。不过因为初始状态为零,所以如果有模式为0的边就不添加了)

代码如下:
#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std;

int match[110][110],vis[110],n,m;
int ye[110];

bool find(int x)
{
    for(int i=1;i<=m;i++)
    {
        if(match[x][i]==1&&!vis[i]) //如果存在x到i的边且该边没有被匹配
        {
            vis[i]=1; //匹配这条边,将该边设为已被访问
            if(ye[i]==-1) //如果该边没有匹配边,设置x为该边的匹配边
            {
                ye[i]=x;
                return true;
            }
            else
            {
                if(find(ye[i])==true)//如果该边被匹配了,寻找边ye[i]是否能与其他边匹配,如果能,空出i的位置
                {
                    ye[i]=x;
                    return true;
                }
            }
        }
    }
    return false;
}

int main()
{
    int k,i,x,y;
    int ans;
    while(~scanf("%d",&n))
    {
        ans=0;
        memset(match,0,sizeof(match));
        memset(ye,-1,sizeof(ye));
        if(n==0)
        {
            break;
        }
        scanf("%d%d",&m,&k);
        while(k--)
        {
            scanf("%d%d%d",&i,&x,&y);
            match[x][y]=1;
        }
        for(int j=1;j<=n;j++)
        {
            memset(vis,0,sizeof(vis));
            if(find(j)==true)
            {
                ans++;
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}

每天刷题,身体棒棒!
时间: 2024-08-06 12:27:38

HDU1150 Machine Schedule(二分图最大匹配、最小点覆盖)的相关文章

hdu - 1150 Machine Schedule (二分图匹配最小点覆盖)

http://acm.hdu.edu.cn/showproblem.php?pid=1150 有两种机器,A机器有n种模式,B机器有m种模式,现在有k个任务需要执行,没切换一个任务机器就需要重启一次, 如果任务i在机器A上执行,A机器需要一个对应的模式A,如果在机器B上执行,机器A需要一个模式B. 一直就是机器A在切换模式,现在让你安排一种合理的任务执行顺序,让机器重启次数最少. 每个任务之间连一条边.二分图的最小顶点覆盖就是求最少的点可以连接所有的边,然后转化成最大匹配即可. 这题就是初始状态

POJ-1325 Machine Schedule 二分图匹配 最小点覆盖问题

POJ-1325 题意: 有两台机器A,B,分别有n,m种模式,初始都在0模式,现在有k项任务,每项任务要求A或者B调到对应的模式才能完成.问最少要给机器A,B调多少次模式可以完成任务. 思路: 相当于是在以n.m个点构成的二分图中,求二分图的最小顶点覆盖数(就是每个任务都涉及到,所需的顶点数).根据Konig定理,二分图的最小顶点覆盖数就是求最大匹配数,注意这里是Base 0的,就是初始不用调整模式就可以完成0模式的任务,所以读入的时候不用考虑与0相连的边. #include <algorit

POJ 1325 Machine Schedule 二分图最大匹配

把每一个任务看做一个边,机器的模式看做是一个点,这个其实就是求一个最少点覆盖所有边即最小点覆盖集的问题,因为最小点覆盖集=二分图的最大匹配,所以问题转化成了求二分图最大匹配问题. 第一次写二分图匹配,感觉建模还是相当困难的. #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #include <climits> #include <strin

ZOJ 1364 Machine Schedule(二分图最大匹配)

题意 机器调度问题 有两个机器A,B A有n种工作模式0...n-1 B有m种工作模式0...m-1 然后又k个任务要做 每个任务可以用A机器的模式i或b机器的模式j来完成 机器开始都处于模式0 每次换模式时都要重启 问完成所有任务机器至少重启多少次 最基础的二分图最大匹配问题 对于每个任务把i和j之间连一条边就可以构成一个二分图 那么每个任务都可以对应一条边 那么现在就是要找最少的点 使这些点能覆盖所有的边 即点覆盖数 又因为二分图的点覆盖数 = 匹配数 那么就是裸的求二分图最大匹配问题了 两

二分图 最大匹配 最小点覆盖 最大独立子集

①一个二分图中的最大匹配数等于这个图中的最小点覆盖数 ②最大独立子集=点数-最小点覆盖数

POJ 1325 Machine Schedule (二分图最小点集覆盖 匈牙利算法)

Machine Schedule Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 12621   Accepted: 5399 Description As we all know, machine scheduling is a very classical problem in computer science and has been studied for a very long history. Scheduli

hdu 1150 Machine Schedule(二分图-最小顶点覆盖)

Machine Schedule Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5424    Accepted Submission(s): 2691 Problem Description As we all know, machine scheduling is a very classical problem in compu

二分图的最小点覆盖和最大独立集

一.二分图的最小点覆盖 无向图的最小点覆盖,就是选取图中最少的点使得每条边至少有一个端点被选中. 而二分图的最小点覆盖 = 最大匹配. 二.二分图的最大独立集 无向图的最大独立集,就是从无向图中选取尽量多的点,这些点两两不邻接. 而二分图的最大独立集 = 点总数 - 最大匹配. 解析见链接:http://hihocoder.com/problemset/problem/1127

UVa12549 Sentry Robots (二分图最大匹配,最小点集覆盖)

题意:http://vjudge.net/problem/UVA-12549 分析: 一个重要位置有(x,y)两个坐标,而要守住这个重要位置就相当于连一条x到y的弧.选了一个重要位置(x,y)放置机器人相当于选了所有x相同的弧或者y相同的弧.当所有的x或者y被选完的时候就完成了看守.具体来说二分图两列分别表示用编号代表行和列,从源点s向行连一条容量为1的弧,从列向汇点t连一条容量为1的弧,再对于每个重要位置(x,y),连一条从x指向y容量为1的弧,跑一次s-t的最大流,最大流出现是当源点s连出去